$PBExportHeader$n_cst_oracle_dw_helper.sru
forward
global type n_cst_oracle_dw_helper from nonvisualobject
end type
type oracommand from structure within n_cst_oracle_dw_helper
end type
type cs_datafmt from structure within n_cst_oracle_dw_helper
end type
end forward

type oracommand from structure
	long		cmdtype
	string		command
	string		name
end type

type cs_datafmt from structure
	character		name[500]
	long		namelen
	long		datatype
	long		format
	long		maxlength
	long		scale
	long		precision
	long		status
	long		count
	long		usertype
	long		cs_local
end type

global type n_cst_oracle_dw_helper from nonvisualobject
end type
global n_cst_oracle_dw_helper n_cst_oracle_dw_helper

type prototypes
PUBLIC FUNCTION Long OCIDescribe(Long svchp, String sqlstmt) LIBRARY 'PBOracle.dll' ALIAS FOR 'OCIDescribe;ANSI'
PUBLIC FUNCTION Long OCICleanUp() LIBRARY 'PBOracle.dll' ALIAS FOR 'OCICleanUp'
PUBLIC FUNCTION Long OCIGetColumnInformation(Long colnum, REF String colname, REF ULong ColType, REF UINT ColSize, REF Long ColPrecision, REF Long ColScale) LIBRARY 'PBOracle.dll' ALIAS FOR 'OCIGetColumnInformation;ANSI'
PUBLIC FUNCTION Long OCIError(Long rec, REF Long errorcode, REF String errortext) LIBRARY 'PBOracle.dll' ALIAS FOR 'OCIError;ANSI'
PUBLIC FUNCTION ULong OCICancel(ULong SrvCxt) LIBRARY "PBOracle.dll"
end prototypes

type variables
CONSTANT Long SQLT_CHR			= 1;		/// (ORANET TYPE) character string.
CONSTANT Long SQLT_NUM			= 2;		/// (ORANET TYPE) oracle numeric.
CONSTANT Long SQLT_INT			= 3;		/// (ORANET TYPE) integer.
CONSTANT Long SQLT_FLT			= 4;		/// (ORANET TYPE) Floating point number.
CONSTANT Long SQLT_STR			= 5;		/// Zero terminated string.
CONSTANT Long SQLT_VNU			= 6;		/// NUM with preceding length byte.
CONSTANT Long SQLT_PDN			= 7;		/// (ORANET TYPE) Packed Decimal Numeric.
CONSTANT Long SQLT_LNG			= 8;		/// Long.
CONSTANT Long SQLT_VCS			= 9;		/// Variable character string.
CONSTANT Long SQLT_NON			= 10;		/// Null/empty PCC Descriptor entry.
CONSTANT Long SQLT_RID			= 11;		/// Rowid.
CONSTANT Long SQLT_DAT			= 12;		/// Date in oracle format.
CONSTANT Long SQLT_VBI			= 15;		/// Binary in VCS format.
CONSTANT Long SQLT_BFLOAT			= 21;		/// Native binary float.
CONSTANT Long SQLT_BDOUBLE			= 22;		/// Native binary double.
CONSTANT Long SQLT_BIN			= 23;		/// Binary data(DTYBIN).
CONSTANT Long SQLT_LBI			= 24;		/// Long binary.
CONSTANT Long SQLT_UIN			= 68;		/// Unsigned integer.
CONSTANT Long SQLT_SLS			= 91;		/// Display sign leading separate.
CONSTANT Long SQLT_LVC			= 94;		/// Longer longs (char).
CONSTANT Long SQLT_LVB			= 95;		/// Longer long binary.
CONSTANT Long SQLT_AFC			= 96;		/// Ansi fixed char.
CONSTANT Long SQLT_AVC			= 97;		/// Ansi Var char.
CONSTANT Long SQLT_IBFLOAT			= 100;		/// Binary float canonical.
CONSTANT Long SQLT_IBDOUBLE		= 101;		/// Binary double canonical.
CONSTANT Long SQLT_CUR			= 102;		/// Cursor  type.
CONSTANT Long SQLT_RDD			= 104;		/// Rowid descriptor.
CONSTANT Long SQLT_LAB			= 105;		/// Label type.
CONSTANT Long SQLT_OSL			= 106;		/// Oslabel type.
CONSTANT Long SQLT_NTY			= 108;		/// Named object type.
CONSTANT Long SQLT_REF			= 110;		/// Ref type.
CONSTANT Long SQLT_CLOB			= 112;		/// Character lob.
CONSTANT Long SQLT_BLOB			= 113;		/// Binary lob.
CONSTANT Long SQLT_BFILEE			= 114;		/// Binary file lob.
CONSTANT Long SQLT_CFILEE			= 115;		/// Character file lob.
CONSTANT Long SQLT_RSET			= 116;		/// Result set type.
CONSTANT Long SQLT_NCO			= 122;		/// Named collection type (varray or nested table).
CONSTANT Long SQLT_VST			= 155;		/// OCIString type.
CONSTANT Long SQLT_ODT			= 156;		/// OCIDate type.
CONSTANT Long SQLT_DATE			= 184;		/// ANSI Date.
CONSTANT Long SQLT_TIME			= 185;		/// TIME.
CONSTANT Long SQLT_TIME_TZ			= 186;		/// TIME WITH TIME ZONE.
CONSTANT Long SQLT_TIMESTAMP		= 187;		/// TIMESTAMP.
CONSTANT Long SQLT_TIMESTAMP_TZ		= 188;		/// TIMESTAMP WITH TIME ZONE.
CONSTANT Long SQLT_INTERVAL_YM		= 189;		/// INTERVAL YEAR TO MONTH.
CONSTANT Long SQLT_INTERVAL_DS		= 190;		/// INTERVAL DAY TO SECOND.

CONSTANT Long SQLT_TIMESTAMP_LTZ		= 232;		/// TIMESTAMP WITH LOCAL TZ.

CONSTANT Long SQLT_PNTY			= 241;		/// pl/sql representation of named types.

CONSTANT Long CS_CHAR_TYPE = 0
CONSTANT Long CS_BINARY_TYPE = 1
CONSTANT Long CS_LONGCHAR_TYPE = 2
CONSTANT Long CS_LONGBINARY_TYPE = 3
CONSTANT Long CS_IMAGE_TYPE = 5
CONSTANT Long CS_TEXT_TYPE = 4
CONSTANT Long CS_TINYINT_TYPE = 6
CONSTANT Long CS_SMALLINT_TYPE = 7
CONSTANT Long CS_INT_TYPE = 8
CONSTANT Long CS_REAL_TYPE = 9
CONSTANT Long CS_FLOAT_TYPE = 10
CONSTANT Long CS_BIT_TYPE = 11
CONSTANT Long CS_DATETIME_TYPE = 12
CONSTANT Long CS_DATETIME4_TYPE = 13
CONSTANT Long CS_MONEY_TYPE = 14
CONSTANT Long CS_MONEY4_TYPE = 15
CONSTANT Long CS_NUMERIC_TYPE = 16
CONSTANT Long CS_DECIMAL_TYPE = 17
CONSTANT Long CS_VARCHAR_TYPE = 18
CONSTANT Long CS_VARBINARY_TYPE = 19
CONSTANT Long CS_LONG_TYPE = 20
CONSTANT Long CS_DATE_TYPE = 27	
CONSTANT Long CS_TIME_TYPE = 28
end variables

forward prototypes
public function string of_replace (string as_source, string as_old, string as_new, boolean ab_ignorecase)
public function string of_stripspecialcharacters (string as_text)
public function long of_getdatatype (long al_datatype)
protected function string of_syntaxfromsql (transaction atr, string as_sql, ref long al_errorcode[], ref string as_error[], long al_backcolor, string as_fontname, long al_fontsize, long al_fontcolor)
end prototypes

public function string of_replace (string as_source, string as_old, string as_new, boolean ab_ignorecase);string ls_return
long ll_len
nv_cppstringx inv_cppstringx

If IsNull(as_source) or IsNull(as_old) or IsNull(as_new) or IsNull(ab_ignoreCase) Then
	string ls_null
	SetNull(ls_null)
	Return ls_null
End If

IF NOT IsValid(inv_cppstringx) THEN
	inv_cppstringx = CREATE nv_cppstringx
END IF

ll_len = inv_cppstringx.of_replaceall( as_source, as_old, as_new, ab_ignorecase )

if ll_len > 0 then
	ls_return = Space ( ll_len )
	inv_cppstringx.of_getoutput ( ls_return , ll_len )
	RETURN ls_return 
end if

Return ls_return
end function

public function string of_stripspecialcharacters (string as_text);String ls_text
Long ll_index, ll_count, ll_len

IF IsNumber(as_text) THEN
	IF Left(as_text, 1) = '-' THEN
		as_text = Mid(as_text, 2, Len(as_text))
	END IF
	RETURN 'x' + as_text
END IF

ll_len = Len(as_text)

FOR ll_index = 1 TO ll_len
	CHOOSE CASE Lower(Mid(as_text, ll_index, 1))
		CASE 'a' to 'z', '_', '0' TO '9' 
			ls_text = ls_text + Mid(as_text, ll_index, 1)
		CASE ' '
			ls_text = ls_text + '_'
	END CHOOSE
NEXT

DO UNTIL Pos(ls_text, "_", 1) <> 1
	ls_text = Right(ls_text, Len(ls_text) - 1)
LOOP


IF IsNumber(Left(ls_Text, 1)) THEN
	ls_text = 'c' + ls_text
END IF

RETURN ls_text
end function

public function long of_getdatatype (long al_datatype);Long ll_newtype

CHOOSE CASE al_datatype
	CASE SQLT_DAT
		ll_newtype = CS_DATE_TYPE
	CASE SQLT_INT
		ll_newtype = CS_INT_TYPE
	CASE SQLT_UIN
		ll_newtype = CS_NUMERIC_TYPE
	CASE SQLT_FLT
		ll_newtype = CS_FLOAT_TYPE
	CASE SQLT_PDN
		ll_newtype = CS_NUMERIC_TYPE
	CASE SQLT_BIN
		ll_newtype = CS_BINARY_TYPE
	CASE SQLT_NUM
		ll_newtype = CS_NUMERIC_TYPE
	CASE SQLT_TIME, SQLT_TIME_TZ
		ll_newtype = CS_TIME_TYPE
	CASE SQLT_TIMESTAMP, SQLT_TIMESTAMP_TZ, SQLT_TIMESTAMP_LTZ
		ll_newtype = CS_DATETIME_TYPE
	CASE SQLT_CHR, SQLT_STR, SQLT_INTERVAL_YM, SQLT_INTERVAL_DS
		ll_newtype = CS_CHAR_TYPE
	CASE ELSE
		ll_newtype = CS_CHAR_TYPE
END CHOOSE

RETURN ll_newtype
end function

protected function string of_syntaxfromsql (transaction atr, string as_sql, ref long al_errorcode[], ref string as_error[], long al_backcolor, string as_fontname, long al_fontsize, long al_fontcolor);String ls_sql
String ls_results
Long ll_return
Long ll_index, ll_collen, ll_rowcount
ULong ColType
UINT ColSize
Long ColPrecision
Long ColScale
Long errorcode
String errortext, ls_syntax
cs_datafmt acs_datafmt[]
String ls_header, ls_table, ls_columns, ls_text
Long ll_datatype
Long ll_x = 0
Integer ll_width
String ls_name, ls_dbname, ls_format, ls_retrieve
Boolean lb_text
ULong ll_handle

ls_sql = as_sql

ll_handle = atr.DBHandle()

ll_return = OCIDescribe(ll_handle, ls_sql)

IF ll_return < 0 THEN
	ll_return = 0
	DO UNTIL ll_return < 0
		ll_index ++
		errortext = Space(2000)
		ll_return = OCIError(ll_index, errorcode, errortext)
		IF ll_return > 0 THEN
			as_error[ll_index] = errortext
			al_errorcode[ll_index] = errorcode
		END IF
	LOOP
	
	RETURN ''
ELSE
	ls_results = Space(500)
	FOR ll_index = 1 TO ll_return
		
		ll_collen = OCIGetColumnInformation(ll_index, ls_results, ColType, ColSize, ColPrecision, ColScale)
		
		acs_datafmt[ll_index].name = Left(ls_results, ll_collen)
		acs_datafmt[ll_index].datatype = of_GetDataType(ColType)
		acs_datafmt[ll_index].namelen = ll_collen
		acs_datafmt[ll_index].scale = ColScale
		acs_datafmt[ll_index].precision = ColPrecision
		IF ColType = SQLT_INTERVAL_YM OR &
		   ColType = SQLT_INTERVAL_DS THEN
			ColSize = ColSize + ColScale + 5
		END IF
		acs_datafmt[ll_index].maxlength = ColSize
		
	NEXT
END IF

OCICleanUp()

ls_header = 'release 10.5; ~r~n' + &
'datawindow(units=0 timer_interval=0 color=' + String(al_backcolor) + ' processing=1 HTMLDW=no print.printername="" print.documentname="" print.orientation = 0 print.margin.left = 110 print.margin.right = 110 print.margin.top = 96 print.margin.bottom = 96 print.paper.source = 0 print.paper.size = 0 print.canusedefaultprinter=yes print.prompt=no print.buttons=no print.preview.buttons=no print.cliptext=no print.overrideprintjob=no print.collate=yes hidegrayline=no grid.lines=0 grid.columnmove=yes selected.mouse=no ) ~r~n' + &
'header(height=60 color="536870912" ) ~r~n' + &
'summary(height=0 color="' + String(al_backcolor) + '" ) ~r~n' + &
'footer(height=0 color="' + String(al_backcolor) + '" ) ~r~n' + &
'detail(height=72 color="536870912" ) ~r~n'

ls_table = ' table( '

ll_rowcount = UpperBound(acs_datafmt)
FOR ll_index = 1 TO ll_rowcount
	
	ll_datatype = acs_datafmt[ll_index].datatype
	ls_name = Trim(String(acs_datafmt[ll_index].name))
	
	IF Len(Trim(ls_name)) = 0 THEN
		ls_dbname = 'column_'
	ELSE
		ls_dbname = of_StripSpecialCharacters(ls_name)
	END IF
	
	IF Len(Trim(ls_dbname)) = 0 THEN
		ls_dbname = 'column_'
	END IF
	
	IF Len(ls_name) < acs_datafmt[ll_index].maxlength THEN
		ll_width = acs_datafmt[ll_index].maxlength * 20
	ELSE
		ll_width = Len(ls_name) * 20
	END IF
	
	IF ll_width < 0 THEN
		ll_width = 2550
	END IF 
	
	ll_width = ll_width + 125
	
	IF acs_datafmt[ll_index].maxlength < 10 THEN
		acs_datafmt[ll_index].maxlength = 10
	END IF
	
	ls_name = of_Replace(ls_name, '"', '~~"', TRUE)
	
	CHOOSE CASE ll_datatype
		CASE CS_CHAR_TYPE, CS_LONGCHAR_TYPE, CS_TEXT_TYPE, CS_VARCHAR_TYPE, CS_IMAGE_TYPE
			ls_table =  ls_table + ' Column=(type=Char(' + String(acs_datafmt[ll_index].maxlength) + ') updatewhereclause=no name=' + ls_dbname + String(ll_index) + ' dbname="' + ls_dbname + '" ) ~r~n'
		CASE CS_DATETIME_TYPE, CS_DATETIME4_TYPE, CS_DATE_TYPE
			IF ll_width < 650 THEN
				ll_width = 650
			END IF
			ls_table =  ls_table + ' Column=(type=datetime updatewhereclause=no name=' + ls_dbname + String(ll_index) + ' dbname="' + ls_dbname + '" ) ~r~n'
		CASE CS_TIME_TYPE
			ls_table =  ls_table + ' Column=(type=time updatewhereclause=no name=' + ls_dbname + String(ll_index) + ' dbname="' + ls_dbname + '" ) ~r~n'
		CASE ELSE
			ls_table =  ls_table + ' Column=(type=Char(50) updatewhereclause=no name=' + ls_dbname + String(ll_index) + ' dbname="' + ls_dbname + '" ) ~r~n'
	END CHOOSE
	
	CHOOSE CASE ll_datatype
		CASE CS_MONEY_TYPE, CS_MONEY4_TYPE, CS_DECIMAL_TYPE, CS_FLOAT_TYPE, CS_NUMERIC_TYPE
			ls_columns =  ls_columns + ' column(band=detail id=' + String(ll_index) + ' alignment="1" tag="dec;' + String(acs_datafmt[ll_index].scale) + '" tabsequence=' + String(ll_index) + ' border="0" color="' + String(al_fontcolor) + '" x="' + String(ll_x + 19) + '" y="8" height="60" width="' + String(ll_width) + '" format="[general]" html.valueishtml="0"  name=' + ls_dbname + String(ll_index) + ' visible="1" edit.limit=0 edit.case=any edit.focusrectangle=no edit.autoselect=yes edit.autohscroll=yes edit.imemode=0 font.face="' + as_fontname + '" font.height="' + String(al_fontsize * -1) + '" font.weight="400"  font.family="2" font.pitch="2" font.charset="0" background.mode="1" background.color="536870912" ) ~r~n'
		CASE CS_TINYINT_TYPE, CS_SMALLINT_TYPE, CS_INT_TYPE,  CS_REAL_TYPE, &
			  CS_LONG_TYPE, CS_BINARY_TYPE, CS_LONGBINARY_TYPE, CS_BIT_TYPE, CS_VARBINARY_TYPE
			ls_columns =  ls_columns + ' column(band=detail id=' + String(ll_index) + ' alignment="1" tag="long" tabsequence=' + String(ll_index) + ' border="0" color="' + String(al_fontcolor) + '" x="' + String(ll_x + 19) + '" y="8" height="60" width="' + String(ll_width) + '" format="[general]" html.valueishtml="0"  name=' + ls_dbname + String(ll_index) + ' visible="1" edit.limit=0 edit.case=any edit.focusrectangle=no edit.autoselect=yes edit.autohscroll=yes edit.imemode=0  font.face="' + as_fontname + '" font.height="' + String(al_fontsize * -1) + '" font.weight="400"  font.family="2" font.pitch="2" font.charset="0" background.mode="1" background.color="536870912" ) ~r~n'
		CASE CS_CHAR_TYPE, CS_LONGCHAR_TYPE, CS_TEXT_TYPE, CS_VARCHAR_TYPE, &
			  CS_DATETIME4_TYPE, CS_IMAGE_TYPE
			
			IF acs_datafmt[ll_index].maxlength = 32767 THEN
				ls_columns =  ls_columns + ' column(band=detail id=' + String(ll_index) + ' alignment="0" tag="char;' + String(acs_datafmt[ll_index].maxlength) + '" tabsequence=' + String(ll_index) + ' border="0" color="' + String(al_fontcolor) + '" x="' + String(ll_x + 19) + '" y="8" height="60" width="' + String(ll_width) + '" format="[general]" html.valueishtml="0"  name=' + ls_dbname + String(ll_index) + ' visible="1" pointer="HyperLink!" edit.limit=0 edit.case=any edit.focusrectangle=no edit.autoselect=yes edit.autohscroll=yes edit.imemode=0  font.face="' + as_fontname + '" font.height="' + String(al_fontsize * -1) + '" font.weight="400"  font.family="2" font.pitch="2" font.charset="0" background.mode="1" background.color="536870912" ) ~r~n'
			ELSE
				ls_columns =  ls_columns + ' column(band=detail id=' + String(ll_index) + ' alignment="0" tag="char;' + String(acs_datafmt[ll_index].maxlength) + '" tabsequence=' + String(ll_index) + ' border="0" color="' + String(al_fontcolor) + '" x="' + String(ll_x + 19) + '" y="8" height="60" width="' + String(ll_width) + '" format="[general]" html.valueishtml="0"  name=' + ls_dbname + String(ll_index) + ' visible="1" edit.limit=0 edit.case=any edit.focusrectangle=no edit.autoselect=yes edit.autohscroll=yes edit.imemode=0  font.face="' + as_fontname + '" font.height="' + String(al_fontsize * -1) + '" font.weight="400"  font.family="2" font.pitch="2" font.charset="0" background.mode="1" background.color="536870912" ) ~r~n'
			END IF
		
		CASE CS_TIME_TYPE
			ls_columns =  ls_columns + ' column(band=detail id=' + String(ll_index) + ' tag="time" alignment="0" tabsequence=' + String(ll_index) + ' border="0" color="' + String(al_fontcolor) + '" x="' + String(ll_x + 19) + '" y="8" height="60" width="' + String(ll_width) + '" format="hh:mm:ss:ffffff" html.valueishtml="0"  name=' + ls_dbname + String(ll_index) + ' visible="1" edit.limit=0 edit.case=any edit.focusrectangle=no edit.autoselect=yes edit.autohscroll=yes edit.imemode=0 font.face="' + as_fontname + '" font.height="' + String(al_fontsize * -1) + '" font.weight="400"  font.family="2" font.pitch="2" font.charset="0" background.mode="1" background.color="536870912" ) ~r~n'
		CASE CS_DATETIME_TYPE, CS_DATE_TYPE
			ls_columns =  ls_columns + ' column(band=detail id=' + String(ll_index) + ' tag="datetime" alignment="0" tabsequence=' + String(ll_index) + ' border="0" color="' + String(al_fontcolor) + '" x="' + String(ll_x + 19) + '" y="8" height="60" width="' + String(ll_width) + '" format="m/d/yyyy hh:mm:ss:ffffff" html.valueishtml="0"  name=' + ls_dbname + String(ll_index) + ' visible="1" edit.limit=0 edit.case=any edit.focusrectangle=no edit.autoselect=yes edit.autohscroll=yes edit.imemode=0 font.face="' + as_fontname + '" font.height="' + String(al_fontsize * -1) + '" font.weight="400"  font.family="2" font.pitch="2" font.charset="0" background.mode="1" background.color="536870912" ) ~r~n'
	END CHOOSE
	
	ls_text =  ls_text + ' text(band=header alignment="0" text="' + ls_name + '" border="0" color="33554432" x="' + String(ll_x + 19) + '" y="8" height="64" width="' + String(ll_width - 25) + '" html.valueishtml="0"  name=' + ls_dbname + String(ll_index) + '_t visible="1" font.face="Tahoma" font.height="-8" font.weight="400"  font.family="2" font.pitch="2" font.charset="0" background.mode="1" background.color="536870912" ) ~r~n'
	
	ll_x = ll_x + ll_width
NEXT


ls_retrieve = 'retrieve=" ' + of_Replace(as_sql, '"', '~~"', FALSE) + '" update="" updatewhere=0 updatekeyinplace=no '

ls_table =  ls_table + ls_retrieve + ' ) ~r~n'

ls_syntax = ls_header + ls_table + ls_text + ls_columns


RETURN ls_syntax

end function

on n_cst_oracle_dw_helper.create
call super::create
TriggerEvent( this, "constructor" )
end on

on n_cst_oracle_dw_helper.destroy
TriggerEvent( this, "destructor" )
call super::destroy
end on

